#ifndef DEFINES_H
#define DEFINES_H






/* This defines how large the CPU load buffer shall be. Having a
   small value makes the termometer response very fast on the
   different CPU load. With 20 it is responsing quite smooth.

 */

#define CPUSMOOTHNESS 20


/* Default size of fishes */
#define DEFAULT_SCALE 50



/* perform clipping outside this range, also this is the size of the
 * drawing area */
/* This is how much that is seen on the screen of the aquarium */

#define XMIN 4
#define XMAX 56
#define YMIN 4
#define YMAX 56

#define WINDOWSIZE_X 64
#define WINDOWSIZE_Y 64

/* How large the aquarium that the fishes lives in. */

#define VIRTUAL_AQUARIUM_DX 80
#define VIRTUAL_AQUARIUM_DY 40


#define VIEWPOINT_START_X  60
#define VIEWPOINT_START_Y  60

/* This is the maximum number of allowed fishes. - Needed for fullscreen */
#define MAX_FISHES 200


/* how many fishes do you want in your aquarium? */
#define NRFISH 10

/* timecop - Are your fishes living in a bubble pool? ;-) 
   32 bubbles are way too many. :-)
*/

#define MAXBUBBLES 10

/* Is this physically illegal? */
#define VARIABLE_BUBBLE_SPEED

/* The number of fishes you have graphic for */
/* WARNING! Don't define more fishes than you have!!! */
#define NUMOFFISHTYPES 17

/* Number of plants, stones and none moving bottom things */
/* Only change if you add new graphics. */
#define NUMOFBOTTOMITEMS 10

/* The number of frames for a bubble */
/* Don't change this, if you are not knowing what you are doing! */
#define BUBBLES_FRAMES 5

#endif
